﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Tilde.MT.WebsiteTranslationService.Models.Database;

#nullable disable

namespace Tilde.MT.WebsiteTranslationService.Migrations
{
    [DbContext(typeof(ServiceDbContext))]
    [Migration("20220830124645_InitialRefactored")]
    partial class InitialRefactored
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.6")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Domain", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<Guid>("WebsiteId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("WebsiteId");

                    b.ToTable("domains");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Language", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(255)");

                    b.HasKey("Id");

                    b.HasIndex("Name")
                        .IsUnique();

                    b.ToTable("languages");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<string>("TextNormalized")
                        .IsRequired()
                        .HasMaxLength(64)
                        .HasColumnType("varchar(64)");

                    b.Property<string>("TextRaw")
                        .IsRequired()
                        .HasMaxLength(5000)
                        .HasColumnType("varchar(5000)");

                    b.Property<string>("Uri")
                        .IsRequired()
                        .HasMaxLength(512)
                        .HasColumnType("varchar(512)");

                    b.Property<Guid>("WebsiteId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("TextNormalized")
                        .HasAnnotation("MySql:IndexPrefixLength", new[] { 64 });

                    b.HasIndex("TextRaw")
                        .HasAnnotation("MySql:IndexPrefixLength", new[] { 768 });

                    b.HasIndex("WebsiteId");

                    b.HasIndex("TextNormalized", "WebsiteId", "Uri")
                        .IsUnique();

                    b.ToTable("segments");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<long?>("AcceptedTranslationId")
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<long>("SegmentId")
                        .HasColumnType("bigint");

                    b.Property<int>("Status")
                        .HasColumnType("int");

                    b.Property<long>("WebsiteTargetLanguageId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasAlternateKey("SegmentId", "WebsiteTargetLanguageId");

                    b.HasIndex("AcceptedTranslationId");

                    b.HasIndex("WebsiteTargetLanguageId");

                    b.ToTable("segment-translations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslationHistory", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<long>("SegmentTranslationId")
                        .HasColumnType("bigint");

                    b.Property<long>("TranslationId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasIndex("SegmentTranslationId");

                    b.HasIndex("TranslationId", "SegmentTranslationId")
                        .IsUnique();

                    b.ToTable("SegmentTranslationHistories");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<int>("Origin")
                        .HasColumnType("int");

                    b.Property<string>("Text")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("Id");

                    b.ToTable("translations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Website", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("char(36)");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<long?>("SourceLanguageId")
                        .HasColumnType("bigint");

                    b.Property<string>("User")
                        .IsRequired()
                        .HasMaxLength(36)
                        .HasColumnType("varchar(36)");

                    b.HasKey("Id");

                    b.HasIndex("SourceLanguageId");

                    b.ToTable("websites");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.WebsiteTargetLanguage", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint");

                    b.Property<DateTime?>("DbCreatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<DateTime?>("DbUpdatedAt")
                        .HasColumnType("datetime(6)");

                    b.Property<long>("LanguageId")
                        .HasColumnType("bigint");

                    b.Property<Guid>("WebsiteId")
                        .HasColumnType("char(36)");

                    b.HasKey("Id");

                    b.HasIndex("LanguageId");

                    b.HasIndex("WebsiteId");

                    b.ToTable("website-target-languages");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Domain", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Website", "Website")
                        .WithMany("Domains")
                        .HasForeignKey("WebsiteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Website");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Website", "Website")
                        .WithMany("Segments")
                        .HasForeignKey("WebsiteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Website");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", "AcceptedTranslation")
                        .WithMany()
                        .HasForeignKey("AcceptedTranslationId");

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", "Segment")
                        .WithMany("SegmentTranslations")
                        .HasForeignKey("SegmentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.WebsiteTargetLanguage", "WebsiteTargetLanguage")
                        .WithMany("SourceSegments")
                        .HasForeignKey("WebsiteTargetLanguageId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AcceptedTranslation");

                    b.Navigation("Segment");

                    b.Navigation("WebsiteTargetLanguage");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslationHistory", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", "SegmentTranslation")
                        .WithMany("SegmentTranslationHistory")
                        .HasForeignKey("SegmentTranslationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", "Translation")
                        .WithMany("SegmentTranslationHistory")
                        .HasForeignKey("TranslationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("SegmentTranslation");

                    b.Navigation("Translation");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Website", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Language", "SourceLanguage")
                        .WithMany("Website")
                        .HasForeignKey("SourceLanguageId");

                    b.Navigation("SourceLanguage");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.WebsiteTargetLanguage", b =>
                {
                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Language", "Language")
                        .WithMany("WebsiteTargetLanguages")
                        .HasForeignKey("LanguageId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Tilde.MT.WebsiteTranslationService.Models.Database.Website", "Website")
                        .WithMany("WebsiteTargetLanguages")
                        .HasForeignKey("WebsiteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Language");

                    b.Navigation("Website");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Language", b =>
                {
                    b.Navigation("Website");

                    b.Navigation("WebsiteTargetLanguages");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Segment", b =>
                {
                    b.Navigation("SegmentTranslations");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.SegmentTranslation", b =>
                {
                    b.Navigation("SegmentTranslationHistory");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Translation", b =>
                {
                    b.Navigation("SegmentTranslationHistory");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.Website", b =>
                {
                    b.Navigation("Domains");

                    b.Navigation("Segments");

                    b.Navigation("WebsiteTargetLanguages");
                });

            modelBuilder.Entity("Tilde.MT.WebsiteTranslationService.Models.Database.WebsiteTargetLanguage", b =>
                {
                    b.Navigation("SourceSegments");
                });
#pragma warning restore 612, 618
        }
    }
}
